// don't forget to "include" this file
// attach action cutcamera_init to an entity

view cutcamera{}

var cut_center;
var max_speed = 7;

action cutcamera_init // attach it to fish.mdl, etc
{
	clip_size = 0; // render all the triangles for all the models

	vec_set (cut_center, my.pos); // store the (relative) center values
	my.skill20 = max_speed; // store the speed

	my.invisible = on;
	my.passable = on;

	camera.visible = off; // disable "camera" view
	cutcamera.visible = on; // make cutcamera visible
	cutcamera.tilt -= 20; // look down
	cutcamera.pos_x = 0;
	cutcamera.pos_y = 0;
	cutcamera.size_x = screen_size.x;
	cutcamera.size_y = screen_size.y;
	ent_path("campath"); // follow this path
	ent_waypoint(my._target_x, 1); // store first waypoint 

	my.x = my._target_x; // start from the first waypoint
	my.y = my._target_y;
	my.z = my._target_z;

	while(1)
	{
		cutcamera.pan -= 10 * mouse_force.x; // 10 = pan speed
		cutcamera.tilt -= 5 * mouse_force.y; // 5 = tilt speed 

		cutcamera.x = my.x;
		cutcamera.y = my.y;
		cutcamera.z = my.z;

		// follow path -> set _speed
		vec_set(my._speed, my._target_x);
		vec_sub(my._speed, my.x); 

		// don't get too close to the target -> find next waypoint
		if (vec_to_angle(my.pan, my._speed) < 15)
		{
			ent_nextpoint(my._target_x);
		} 

		// turn the camera towards its center (cut_center)
		//vec_set (temp, cut_center.x);
		//vec_sub (temp, my.x);
		//vec_to_angle (my.pan, temp); 

		vec_normalize(my._speed, (max_speed * time)); // normalize _speed
		
		if (key_s != 1) // press "S" to stop the movement
		{
			ent_move(nullskill, my._speed); 
		}

		// add some spices
		if (my.z < 190) // get this value in wed
		{
			max_speed = max (my.skill20 / 2, max_speed * 0.995);  
		}
		else
		{
			max_speed = min (my.skill20, max_speed * 1.005);
		}

		wait(1);
	} 
}

